#property copyright "Expert for tests"

extern double Lots = 0.1 ;
extern int max_trades = 10 ;
extern int grid_lines = 30 ;
extern double RangeMid = 1.5465 ;
extern double grid_separation = 0.0100 ;
extern double TP_absolute = 0.0050 ;
extern int slip = 3 ;
extern double pipvalue = 0.01 ;
   
int BarCount;
int Current;
bool TickCheck = False;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {

   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
 
   int Entertradebuy =0 ;
   int Entertradesell =0 ;
   double level ;
   
   if(OrdersTotal()<max_trades)
   {
  for (int i = 1; i<grid_lines; i++) 
   {
   if (Ask == RangeMid - grid_separation*i && level != RangeMid - grid_separation*i)
   {
   Entertradebuy=1 ;
   }
   if (Bid == RangeMid + grid_separation*i && level != RangeMid + grid_separation*i)
   {
   Entertradesell=1 ; 
   }
   }
   }
   
   int iOrders = OrdersTotal()-1;

for (i = iOrders; i>=0; i--)

{
OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
if (OrderOpenPrice() == Ask || OrderOpenPrice() == Bid)
{
Entertradebuy=0  ;
Entertradesell=0 ;
}
} 
   
   
   if(Entertradebuy==1)
   {
   double Ticket1 = OrderSend(Symbol(), OP_BUY, Lots, Ask, 5, 0, Ask+TP_absolute, "Buy(#" + 1 + ")", 1, 0, DodgerBlue)   ;       
   }
   
   
   if(Entertradesell==1)
   {
   double Ticket2 = OrderSend(Symbol(), OP_SELL, Lots, Bid, slip, 0, Bid-TP_absolute, "Sell(#" + 1 + ")", 1, 0, DeepPink) ;
   }
   
for (i = 1; i<grid_lines; i++)
{
if(Ask - (RangeMid - grid_separation*i) < grid_separation && level != RangeMid - grid_separation*i)
GlobalVariableSet("next_level", RangeMid - grid_separation*i) ;
if(RangeMid + grid_separation*i - Bid < grid_separation && level != RangeMid + grid_separation*i)
GlobalVariableSet("next_level", RangeMid + grid_separation*i) ;
}

double next_level=GlobalVariableGet("next_level") ;

for (i = 1; i<grid_lines-1; i++)
double pips_risked = pips_risked+(((RangeMid+grid_separation*grid_lines)-(RangeMid-grid_separation*(grid_lines-i))));

double money_risked = (pips_risked*10000)/2 ;

if (OrdersTotal() < max_trades)
Comment("I am trading a grid from ", RangeMid-grid_separation*grid_lines, " to ", RangeMid+grid_separation*grid_lines, "\n",
        "closest grid line to enter trade is ", next_level , "\n", 
        "distance between grid lines is ", grid_separation*10000, " pips", "\n",
        "number of grid lines is ", grid_lines, "\n",
        "maximum number of trades is ", max_trades, "\n",
        "TP is ", TP_absolute,  "\n",
        "---------------------------------------------------",  "\n",
        "You are risking a potential ", money_risked, "USD")  ;     
        
if(OrdersTotal() >= max_trades)
Comment("I am full, I have ", max_trades, " positions opened");
        

   return(0);
}
//+------------------------------------------------------------------+